//+------------------------------------------------------------------+
//|                                               StochColorBars.mq4 |
//|                                      Copyright  2004-35, banzai |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004-35, banzai"
#property link      "http://www.forex-tsd.com/indicators-metatrader-4/4108-stochastic-color-bar.html"

#property indicator_separate_window
#property indicator_buffers   2
#property  indicator_minimum 0
#property  indicator_maximum 1
#property indicator_color1 Lime //Uptrend
#property indicator_width1 4
#property indicator_color2 Red //Downtrend
#property indicator_width2 4
//#property indicator_color3 DarkGreen //Overbought
//#property indicator_color4 Maroon //Oversold
 
extern string note1 = "Chart Time Frame";
extern string note2 = "0=current time frame";
extern string note3 = "1=M1, 5=M5, 15=M15, 30=M30";
extern string note4 = "60=H1, 240=H4, 1440=D1";
extern string note5 = "10080=W1, 43200=MN1";
extern int	TimeFrame	= 0;		
extern string note6 = "Stochastic settings";
extern int       KPeriod     =  5;
extern int       DPeriod     =  3;
extern int       Slowing     =  3;
extern string note7 = "0=sma, 1=ema, 2=smma, 3=lwma";
extern int       MAMethod    =   0;
extern string note8 = "0=high/low, 1=close/close";
extern int       PriceField  =   0;
//extern string note9 = "overbought level";
//extern int       overBought  =  80;
//extern string note10 = "oversold level";
//extern int       overSold    =  20;
extern int    MaximumBars=192;

double Uptrend[];
double Downtrend[];
double Upper[];
double Lower[];
string	IndicatorName = "", IndicatorName2 = "", StochName = "";

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
{
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,4,indicator_color1);
   SetIndexBuffer(0,Uptrend);
   SetIndexLabel(0,"Uptrend");
   
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,4,indicator_color2);
   SetIndexBuffer(1,Downtrend);
   SetIndexLabel(1,"Downtrend");
/*   
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,4,indicator_color3);
   SetIndexBuffer(2,Upper);
   SetIndexLabel(2,"Upper");   
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID,4,indicator_color4);
   SetIndexBuffer(3,Lower);
   SetIndexLabel(3,"Lower");          
*/         
	switch(TimeFrame)
	{
		case 1:		IndicatorName2="M1";	break;
		case 5:		IndicatorName2="M5"; break;
		case 10:		IndicatorName2="M10"; break;
		case 15:		IndicatorName2="M15"; break;
		case 30:		IndicatorName2="M30"; break;
		case 60:		IndicatorName2="H1"; break;
		case 120:	IndicatorName2="H2"; break;
		case 240:	IndicatorName2="H4"; break;
		case 480:	IndicatorName2="H8"; break;
		case 1440:	IndicatorName2="D1"; break;
		case 10080:	IndicatorName2="W1"; break;
		case 43200:	IndicatorName2="MN1"; break;
		default:	   TimeFrame = Period(); break;
	}
   StochName = " StochBars ("+KPeriod+","+DPeriod+","+Slowing+")";
	IndicatorName = IndicatorName2+StochName;
	IndicatorShortName(IndicatorName);  
	IndicatorDigits(1);
   return(0);
}
//+------------------------------------------------------------------+
int deinit()
{
   return(0);
}
//+------------------------------------------------------------------+
int start()
{
   datetime TimeArray[];
   int    banzai,buckaroo,counted_bars=IndicatorCounted();
   double percentK, percentD;
    
      if ((TimeFrame != 10) && (TimeFrame != 120) && (TimeFrame != 480)) {
          ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
      }
      else {
      	   switch(TimeFrame)
	         {
		       case 10:	{
                         ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),30); 
		                   break;
		                  }
		       case 120:	{
                         ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),240); 
		                   break;
		                  }
		       case 480:	{
                         ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),1440); 
		                   break;
		                  }
   	      }
           }

   
   if(counted_bars<0) return(-1);
   for(banzai=0,buckaroo=0;banzai<MaximumBars;banzai++)
   {
            if (Time[banzai]<TimeArray[buckaroo]) buckaroo++; 
      if ((TimeFrame != 10) && (TimeFrame != 120) && (TimeFrame != 480)) {
            percentK = iStochastic(NULL,TimeFrame,KPeriod,DPeriod,Slowing,MAMethod,PriceField,MODE_MAIN,buckaroo);
            percentD = iStochastic(NULL,TimeFrame,KPeriod,DPeriod,Slowing,MAMethod,PriceField,MODE_SIGNAL,buckaroo);
      }
      else {
      	   switch(TimeFrame)
	         {
		       case 10:	{
                         percentK = iStochastic(NULL,30,KPeriod,DPeriod,Slowing,MAMethod,PriceField,MODE_MAIN,buckaroo)/3;
                         percentD = iStochastic(NULL,30,KPeriod,DPeriod,Slowing,MAMethod,PriceField,MODE_SIGNAL,buckaroo)/3;
		                   break;
		                  }
		       case 120:	{
                         percentK = iStochastic(NULL,240,KPeriod,DPeriod,Slowing,MAMethod,PriceField,MODE_MAIN,buckaroo)/2;
                         percentD = iStochastic(NULL,240,KPeriod,DPeriod,Slowing,MAMethod,PriceField,MODE_SIGNAL,buckaroo)/2;
		                   break;
		                  }
		       case 480:	{
                         percentK = iStochastic(NULL,1440,KPeriod,DPeriod,Slowing,MAMethod,PriceField,MODE_MAIN,buckaroo)/3;
                         percentD = iStochastic(NULL,1440,KPeriod,DPeriod,Slowing,MAMethod,PriceField,MODE_SIGNAL,buckaroo)/3;
		                   break;
		                  }
   	      }
           }

            if (percentK > percentD)   { Uptrend[banzai]   = 1;}
            if (percentK < percentD)   { Downtrend[banzai] = 1;}
//            if (percentK >= overBought) { Upper[banzai]     = 1;}
//            if (percentK <= overSold)   { Lower[banzai]     = 1;}                   
    }
 
   return(0);
}


